import { __decorate } from 'tslib';
import { EventEmitter, ɵɵdefineInjectable, Injectable, NgModule } from '@angular/core';

var NgAudioRecorderService = /** @class */ (function () {
    function NgAudioRecorderService() {
        var _this = this;
        this.chunks = [];
        this.recorderEnded = new EventEmitter();
        this.appendToChunks = function (event) {
            _this.chunks.push(event.data);
        };
        this.recordingStopped = function (event) {
            var blob = new Blob(_this.chunks, { type: 'audio/webm' });
            _this.chunks = [];
            _this.recorderEnded.emit(blob);
            _this.clear();
        };
    }
    NgAudioRecorderService_1 = NgAudioRecorderService;
    NgAudioRecorderService.getUserConsent = function () {
        return navigator.mediaDevices.getUserMedia({ audio: true });
    };
    NgAudioRecorderService.prototype.startRecording = function () {
        var _this = this;
        NgAudioRecorderService_1.getUserConsent().then(function (mediaStream) {
            _this.recorder = new MediaRecorder(mediaStream);
            _this.addListeners();
            _this.recorder.start();
        });
    };
    NgAudioRecorderService.prototype.stopRecording = function (outputFormat) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.recorderEnded.subscribe(function (blob) {
                if (outputFormat === OutputFormat.BLOB) {
                    resolve(blob);
                }
                if (outputFormat === OutputFormat.BLOB_URL) {
                    var audioURL = URL.createObjectURL(blob);
                    resolve(audioURL);
                }
            });
            _this.recorder.stop();
        });
    };
    NgAudioRecorderService.prototype.addListeners = function () {
        this.recorder.ondataavailable = this.appendToChunks;
        this.recorder.onstop = this.recordingStopped;
    };
    NgAudioRecorderService.prototype.clear = function () {
        this.recorder = null;
        this.chunks = [];
    };
    var NgAudioRecorderService_1;
    NgAudioRecorderService.ɵprov = ɵɵdefineInjectable({ factory: function NgAudioRecorderService_Factory() { return new NgAudioRecorderService(); }, token: NgAudioRecorderService, providedIn: "root" });
    NgAudioRecorderService = NgAudioRecorderService_1 = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], NgAudioRecorderService);
    return NgAudioRecorderService;
}());
var OutputFormat;
(function (OutputFormat) {
    OutputFormat[OutputFormat["BLOB_URL"] = 0] = "BLOB_URL";
    OutputFormat[OutputFormat["BLOB"] = 1] = "BLOB";
})(OutputFormat || (OutputFormat = {}));

var NgAudioRecorderModule = /** @class */ (function () {
    function NgAudioRecorderModule() {
    }
    NgAudioRecorderModule = __decorate([
        NgModule({
            declarations: [],
            imports: [],
            exports: [],
            providers: [
                NgAudioRecorderService
            ]
        })
    ], NgAudioRecorderModule);
    return NgAudioRecorderModule;
}());

/*
 * Public API Surface of ng-audio-recorder
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgAudioRecorderModule, NgAudioRecorderService, OutputFormat };
//# sourceMappingURL=ng-audio-recorder.js.map
